/***************************************************************************
 *   Copyright (C) 2004 by Christoph Freundl                               *
 *   Christoph.Freundl@informatik.uni-erlangen.de                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef SDLWIDGETS_FONTFACTORY_H
#define SDLWIDGETS_FONTFACTORY_H

#include <string>
#include <map>
#include <SDL.h>
#include <SDL_ttf.h>

namespace SDLwidgets {

class FontFactory {
public:
	typedef std::map<int, TTF_Font*> SizeMap;
	typedef std::map<std::string, SizeMap*> FontMap;
private:
	std::string _font_path;
	FontMap _font_map;
	static FontFactory* _instance;
public:
	~FontFactory();
	static FontFactory* getInstance();
	static void deleteInstance();
	void setFontPath( std::string path ) {
		_font_path = path;
	}
	TTF_Font* createFont( std::string name, int size );
protected:
	FontFactory();
};

}

#endif // SDLWIDGETS_FONTFACTORY_H
