/* $Id: invisiblecorona.hpp,v 1.4 2005/06/28 13:55:20 chfreund Exp $ */

#ifndef _INVISIBLECORONA_HPP_
#define _INVISIBLECORONA_HPP_

/**********************************************************/

#include "noncollidableobject.hpp"

/**********************************************************/

//! the corona effect surrounding an avatar, that picked up a invisible bonus
class InvisibleCorona : public NonCollidableObject
{
	public:

		InvisibleCorona();
		~InvisibleCorona();

		//! return object ID
		Sint32 getID() const { return INVISIBLE_CORONA; }

		//! updates the object
		void update();
		//! signalizes the corona to shut down
		void signalShutdown();
		//!
		void reboot();

		//! \name (de)serialization
		//@{
		Uint32 getSerializeBufferSize() const;
		void serialize( Uint8*& bufferPointer ) const;
		void deserialize( Uint8*& bufferPointer );
		//@}

	protected:

		enum { FORWARD = 1, BACKWARD = -1 };
		Sint32 m_direction;
};

/**********************************************************/

#endif // _INVISIBLECORONA_HPP_
