/* $Id: weaponguidedmissile.hpp,v 1.1 2005/07/17 12:11:04 pohlt Exp $ */

#ifndef _WEAPONGUIDEDMISSILE_HPP_
#define _WEAPONGUIDEDMISSILE_HPP_

/**********************************************************/

#include "weapon.hpp"
#include "guidedmissile.hpp"
#include "audio.hpp"

/**********************************************************/

class WeaponGuidedMissile : public Weapon
{
	public:
	
		WeaponGuidedMissile() {
			m_ID          = WEAPON_GUIDED_MISSILE;
			m_maximumAmmo =   1;
			m_reloadTime  =  15;
			m_chargeTime  = 100;
			rechargeNow();
			// load sample for fire action
			m_shotSample = Audio::getInstance()
			    ->loadSound( "sound/weapons/missile/launch.wav" );
			// load sample for explosion
			GuidedMissile::m_explodeSample = Audio::getInstance()
			    ->loadSound( "sound/effects/explosion1.wav" );
			// load sample for this cool "pling, pling" :)
			GuidedMissile::m_damageSample = Audio::getInstance()
			    ->loadSound( "sound/effects/ricochet.wav" );
		}

		virtual bool reallyShoot( World* world, Avatar* avatar,
		                          const StationaryGun* gun = NULL ) const;
};

/**********************************************************/

#endif // _WEAPONGUIDEDMISSILE_HPP_
